Subject: Re: pull-request: mlx5-next 2023-01-24 V2

From: Jakub Kicinski <[email-masked]>
Date: Wed, 8 Feb 2023 16:48:07 -0800

On Wed, 8 Feb 2023 20:27:17 -0400 Jason Gunthorpe wrote:
> On Wed, Feb 08, 2023 at 03:19:22PM -0800, Jakub Kicinski wrote:
> > On Wed, 8 Feb 2023 12:13:00 -0400 Jason Gunthorpe wrote:  
> > > I can't accept yours because it means RDMA stops existing. So we must
> > > continue with what has been done for the last 15 years - RDMA
> > > (selectively) mirrors the IP and everything running at or below the IP
> > > header level.  
> > 
> > Re-implement bits you need for configuration, not stop existing.  
> 
> This is completely technically infeasible. They share IP addresess, we
> cannot have two stacks running IPSEC on top of othe same IP address
> without co-ordinating. Almost every part is like that to some degree.
> 
> And even if we somehow did keep things 100% seperated, with seperated
> IPs - Linus isn't going to let me copy and paste the huge swaths of
> core netdev code required to do IP stuff (arp, nd, routing, icmp,
> bonding, etc) into RDMA for a reason like this.
> 
> So, it really is a complete death blow to demand to keep these things
> separated.
> 
> Let alone what would happen if we applied the same logic to all the
> places sharing the IP with HW - remember iscsi? FCoE?

Who said IP configuration.

> > > What do you mean? "make it all the same" can be done with private or
> > > open standards?  
> > 
> > Oh. If it's someone private specs its probably irrelevant to the open
> > source community?  
> 
> No, it's what I said I dislike. Private specs, private HW, private
> userspace, proprietary kernel forks, but people still try to get
> incomplete pieces of stuff into the mainline kernel.
> 
> > Sad situation. Not my employer and not in netdev, I hope.  
> 
> AFAIK your and my employer have done a good job together on joint
> projects over the years and have managed to end up with open source
> user spaces for almost everything subtantive in the kernel.

Great. Let's make a note of that so there are not more accusations 
that my objectives for netdev are somehow driven by evil hyperscalers.

> > > I have no idea how you are jumping to some conclusion that since the
> > > RDMA team made their patches it somehow has anything to do with the
> > > work Leon and the netdev team will deliver in future?  
> > 
> > We shouldn't reneg what was agreed on earlier.  
> 
> Who reneg'd? We always said we'd do it and we are still saying we plan
> to do it.
> 
> > > Hasn't our netdev team done enough work on TC stuff to earn some
> > > faith that we do actually care about TC as part of our portfolio?  
> > 
> > Shouldn't have brought it up in the past discussion then :|
> > Being asked to implement something tangential to your goals for 
> > the community to accept your code is hardly unheard of.  
> 
> We agreed to implement. I'm asking for patience since we have a good
> historical track record.

If you can't make a strong commitment, what's the point in time,
at which if I were angry that the tc redirect was not posted yet -
you'd consider it understandable?
Perhaps that's sufficiently not legally binding? :)